#include "local/Macros.h"
IDENTIFY("dlsym: see man dlsym(3)");

#include <stdio.h>
#include <signal.h>

#include <dlfcn.h>

#if !defined(linux) && !defined(__MACH__)
extern char *sys_errlist[];
#endif
extern char *getenv();
extern int errno, system();

main( int argc, char *argv[])
{ int i, r= 1;
  void *lib;
#if defined(__MACH__) || defined(__APPLE_CC__)
  Dl_info info;
#endif
	if( argc> 1 ){
	  char *err;
		lib= dlopen(argv[1], RTLD_LOCAL|RTLD_LAZY);
		err= (char*) dlerror();
		if( lib && !err ){
			for( i= 2; i< argc; i++ ){
			  void *sym= dlsym( lib, argv[i] );
				err= dlerror();
				if( sym && !err ){
					fprintf( stderr, "%s::%s: %p", argv[1], argv[i], sym );
#if defined(__MACH__) || defined(__APPLE_CC__)
					if( sym ){
						if( dladdr( sym, &info) ){
							fprintf( stderr, " (%s::%s)", info.dli_fname, info.dli_sname );
						}
					}
#endif
					fputc( '\n', stderr );
				}
				else{
					fprintf( stderr, "%s: error retrieving %s::%s (%s)\n",
						argv[0], argv[1], argv[i], err
					);
				}
			}
			dlclose(lib);
			err= dlerror();
			if( err ){
				fprintf( stderr, "%s: error closing %s (%s)\n",
					argv[0], argv[1], err
				);
			}
			else{
				r= 0;
			}
		}
		else{
			fprintf( stderr, "%s: can't open %s (%s)\n",
				argv[0], argv[1], err
			);
		}
	}
	exit(r);
}
